<template>
  <component
    :is="component"
    :to="url"
    class="button"
    :class="{
      [`button--size-${size}`]: !!size,
      [`button--state-${state}`]: !!state,
    }"
    @click="onClick"
  >
    <slot name="before" />
    <span class="button__label">
      <slot />
    </span>
    <slot name="after" />
  </component>
</template>

<script>
export default {
  name: 'Button',
  props: {
    size: {
      type: String,
      default: 'sm',
    },
    state: String,
    url: [String, Object],
  },
  computed: {
    component() {
      return this.url ? 'nuxt-link' : 'button';
    },
  },
  methods: {
    onClick() {
      this.$emit('click');
    },
  },
};
</script>

<style lang="scss">
  @import "../../assets/variables";
  .button {
    $root: &;
    display: flex;
    align-items: center;
    cursor: pointer;

    @each $key, $height, $padding, $font, $margin in (
        (sm, 50px, 16px, 18px, 8px),
    ) {
      &--size-#{$key} {
        height: $height;
        padding: 0 $padding;
        font-size: $font;
      }

      &__label {
        * + & {
          margin-left: $margin;
        }
        + * {
          margin-left: $margin
        }
      }
    }

    &--state-danger {
      border-radius: 6px;
      box-shadow:
        0 1px 1px transparentize($color-black, .8),
        0 1px 0 2px transparentize($color-red, .7);
      color: $color-red;
      background: $color-white;
    }

    &--state-success {
      border-radius: 6px;
      box-shadow:
        0 1px 1px transparentize($color-black, .8),
        0 1px 0 2px transparentize($color-softGreen, .7);
      color: $color-softGreen;
      background: $color-white;
    }

    &--state-successOutline {
      border-radius: 6px;
      box-shadow:
        0 1px 1px transparentize($color-black, .8);
      color: $color-green;
      background: $color-white;
    }

    &--state-successFilled {
      border-radius: 6px;
      box-shadow:
        0 1px 1px transparentize($color-black, .8);
      color: $color-white;
      background: $color-green;
    }
  }
</style>
